# Redefine macro __debug_install_post to strip -l<digit> information.
%define __debug_install_post_hpe  %{lua:
	local var   = "__debug_install_post"
        local dip   = "%{" .. var .. "}"
        local orig  = rpm.expand(dip)
	-- Remove -lXX when calling find-debuginfo.sh
        local new   = string.gsub(orig, "-l%d+", "")
	-- Redefine __debug_install_post macro quoting stuff properly
        rpm.undefine(var)
	-- ... and removing double-quote at the beginning/end.
        rpm.define(var .. " " .. string.sub(string.format("%q",new),2,-2))
        }
Summary: GRU Driver and Headers
Name: gru
DistTag: RELEASE=hawks245,DISTRO=suse,DISTRO_VERSION=1530,DISTRO_OS=sles15sp3gm,DIST=sles15sp3,SRC=opensource/gru
Group: System Environment/Base
Version: 1.0
Release: 740.1530.220526T1038.r.sles15sp3hpe
License: GPL
Vendor: Hewlett Packard Enterprise Company
Packager: Hewlett Packard Enterprise Company
Distribution:  HPE(R) Foundation Software
Source0: %{name}-%{version}.tar.bz2
Source1: sles15sp3-kernel-module-subpackage
Source2: kmp-modvers-subpackage
BuildRoot: /var/tmp/%{name}-root

# Note: Temporarily build only for the UV variant. The final version
# of the spec file should uncomment the line below & delete the
# following line.
#
# BuildRequires: kernel-hpedev-base kernel-hpedev-source kernel-source kernel-syms kernel-uv-base kernel-uv-source
BuildRequires: kernel-source kernel-syms kernel-hpedev-source kernel-hpedev-devel kernel-default kernel-default-devel
Requires: %([ %_vendor = suse ] && echo hpe-gru-kmp || echo gru-kmod)

%define kmodule gru
# XXX: Changed from 1 to 2 ( stout7sp1 )
#      Possible values: either boot|1 or initrd|2
%define autoload_module initrd
%define excluded_kernels %([ %{_vendor} = "suse" ] && echo xen || echo "")
%suse_kernel_module_package -s %_sourcedir/sles15sp3-kernel-module-subpackage -n hpe-%{kmodule} preempt kdump  %{excluded_kernels}

# build hpe-%{kmodule}-kmp-modvers subpackage
%{expand:%(cd %_sourcedir; cat %SOURCE2)}

%define install_mod_dir %([ %_vendor = suse ] && echo updates || echo extra)

%description
The GRU (Global Reference Unit) is a significant hardware addition to
the UV hub chip. The GRU hardware provides fast and reliable
communication between nodes within and across SSIs within a
numalink-connected cluster.

The GRU hardware is used by:

    - kernel for all cross partition communications
    - MPI for all cross partition communications. In addition, it is used
      for offnode references within an SSI. The GRU has features (ex.,
      message queues) developed specifically to benefit MPI
      communications.
    - UPC (unified parallel C)
    - directly by user application that are specially written to use the
      GRU directly

%package devel
Summary: Devel package for the UV GRU.
Group: Development/Libraries

%description devel
This package contains GRU header files for building applications that
directly use the GRU hardware.

%prep
%setup -q -n %{name}
autoreconf -if

%build
%if "" == "TRUE"
find . -name "*.c" -print0 | xargs -0 sed -i '/MODULE_LICENSE(/a MODULE_INFO(retpoline, "Y");'
export KCFLAGS='-mindirect-branch=thunk-inline -mindirect-branch-register'
%endif
./configure --prefix=/usr --libdir=%{_libdir} --mandir=/usr/share/man	\
	--with-kernel-kbuild-dirs='/lib/modules/*/build'		\
	--with-install-mod-dir=%install_mod_dir
make

%install
# Redefine macro __debug_install_post to strip -l<digit> information.
rpm --eval '%{__debug_install_post_hpe}'
rm -rf $RPM_BUILD_ROOT
make DESTDIR="$RPM_BUILD_ROOT" install

%clean
rm -rf $RPM_BUILD_ROOT

%files devel
%defattr(-,root,root)
%attr(644,root,root) /usr/include/uv/gru/gru.h
%attr(644,root,root) /usr/include/uv/gru/gru_instructions.h
%attr(644,root,root) /usr/include/uv/gru/gru_mesq.h
%attr(644,root,root) /usr/include/uv/gru/gru_mesq_internals.h
%attr(644,root,root) /usr/include/uv/gru/grulib.h
%attr(644,root,root) /usr/include/uv/gru/gruhandles.h
%attr(644,root,root) /usr/include/linux/uv/grukservices.h
%attr(644,root,root) /usr/include/linux/uv/gru_instructions.h
%attr(644,root,root) /usr/include/linux/uv/gru.h
%attr(644,root,root) /usr/include/linux/uv/grulib.h
%attr(644,root,root) /usr/include/linux/uv/gru_mesq_internals.h
%attr(644,root,root) /usr/include/linux/uv/gru_rev_2_wars.h
%attr(644,root,root) /usr/include/linux/uv/gru_ugly_kabi_hack.h
